NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Facet::FillHoleBuilder Class Reference

This class finds and fills holes to a prescribed boundary smoothness condition. More...

Inheritance diagram for NXOpen::Facet::FillHoleBuilder:
NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder

Public Types

enum  SmoothTypes { SmoothTypesLinear, SmoothTypesRefined, SmoothTypesTangentBased, SmoothTypesCurvatureBased }
 Smoothness and boundary continuity options. More...
 
enum  TargetTypes { TargetTypesUserDefined, TargetTypesByNumberOfEdges }
 Options defining how to target holes for filling. More...
 
enum  Types { TypesFillHole, TypesFillIsland, TypesBridgeGap }
 Hole filling type options. More...
 

Public Member Functions

NXOpen::SelectICurveListBridgeEdges1 ()
 Returns the first list of edges when bridging holes. More...
 
NXOpen::SelectICurveListBridgeEdges2 ()
 Returns the second list of edges when bridging holes. More...
 
void ClearHoleFills ()
 Cleans up local meshes associated with each fill. More...
 
void ClearHoles ()
 Removes all holes, deletes associated hole polylines. More...
 
NXOpen::DisplayableObjectFillHoles (bool globalUpdate)
 Fills targeted holes. More...
 
void FindHoles ()
 Locates holes in the mesh and creates polylines around them. More...
 
void GetAllHoles (std::vector< NXOpen::DisplayableObject * > &holeCurveTags)
 Gets a list of all holes (represented by polylines). More...
 
NXOpen::ICurveGetHoleByIndex (int index)
 Gets a hole given an index into the list of holes. More...
 
NXOpen::DisplayableObjectGetHoleFillsOnly ()
 Builds a facet body that contains only the facets of the filled holes. More...
 
int GetNumberOfHoles ()
 Gets the number of holes in the target facet body. More...
 
void GetTargetHolesByEdgeNumber (int numMaxEdges, std::vector< NXOpen::DisplayableObject * > &holeCurveTags)
 Gets a list of targeted holes (represented by polylines) based on number of edges. More...
 
NXOpen::SelectICurveListInnerHole ()
 Returns the Inner Hole in island filling. More...
 
bool IsEditCopy ()
 Returns the flag indicating if the hole filling is on the copy of the input facet body. More...
 
int MaxEdges ()
 Returns the maximum number of edges that a targeted hole can have. More...
 
NXOpen::SelectICurveListOuterHole ()
 Returns the Outer Hole in island filling. More...
 
void SetEditCopy (bool isEditCopy)
 Sets the flag indicating if the hole filling is on the copy of the input facet body. More...
 
void SetMaxEdges (int maxEdges)
 Sets the maximum number of edges that a targeted hole can have. More...
 
void SetSmoothType (NXOpen::Facet::FillHoleBuilder::SmoothTypes smoothType)
 Sets the boundary smoothness. More...
 
void SetTargetType (NXOpen::Facet::FillHoleBuilder::TargetTypes targetType)
 Sets the hole target type when filling holes. More...
 
void SetType (NXOpen::Facet::FillHoleBuilder::Types type)
 Sets the hole filling type. More...
 
NXOpen::Facet::FillHoleBuilder::SmoothTypes SmoothType ()
 Returns the boundary smoothness. More...
 
void SwitchHoleFillType ()
 Switches boundary edge mapping based on the filling type (holes, island, bridge) When filling holes or islands, each hole is defined by a polyline. More...
 
NXOpen::SelectDisplayableObjectTargetBody ()
 Returns the facet body we will be filling. More...
 
NXOpen::Facet::SelectFacetedBodyTargetFacetBody ()
 Returns the facet body we will be filling. More...
 
NXOpen::SelectICurveListTargetHole ()
 Returns the hole curves using Fill Hole, User Defined. More...
 
NXOpen::Facet::FillHoleBuilder::TargetTypes TargetType ()
 Returns the hole target type when filling holes. More...
 
NXOpen::Facet::FillHoleBuilder::Types Type ()
 Returns the hole filling type. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

This class finds and fills holes to a prescribed boundary smoothness condition.

Inputs to this class can be convergent objects.
To create a new instance of this class, use NXOpen::Facet::FacetedBodyCollection::CreateFillHoleBuilder
Default values.

Property Value

IsEditCopy

0

MaxEdges

0

SmoothType

Linear

TargetType

UserDefined


Created in NX6.0.0.

Member Enumeration Documentation

Smoothness and boundary continuity options.

Enumerator
SmoothTypesLinear 

Linear (triangulated) fill.

SmoothTypesRefined 

Smooth internal fill.

SmoothTypesTangentBased 

Smooth fill, boundary is based on facet body tangent.

SmoothTypesCurvatureBased 

Smooth fill, boundary is based on facet body curvature.

Options defining how to target holes for filling.

Enumerator
TargetTypesUserDefined 

Fills user-defined target holes.

TargetTypesByNumberOfEdges 

Automatically target holes based on number of edges.

Hole filling type options.

Enumerator
TypesFillHole 

Fills individual hole(s).

TypesFillIsland 

Fills a hole defined by inner island and outer facet body.

TypesBridgeGap 

Bridges some open boundary edges with a linear fill.

Member Function Documentation

NXOpen::SelectICurveList* NXOpen::Facet::FillHoleBuilder::BridgeEdges1 ( )

Returns the first list of edges when bridging holes.


Created in NX6.0.0.

License requirements : None

NXOpen::SelectICurveList* NXOpen::Facet::FillHoleBuilder::BridgeEdges2 ( )

Returns the second list of edges when bridging holes.


Created in NX6.0.0.

License requirements : None

void NXOpen::Facet::FillHoleBuilder::ClearHoleFills ( )

Cleans up local meshes associated with each fill.


Created in NX6.0.0.

License requirements : None

void NXOpen::Facet::FillHoleBuilder::ClearHoles ( )

Removes all holes, deletes associated hole polylines.


Created in NX6.0.0.

License requirements : None

NXOpen::DisplayableObject* NXOpen::Facet::FillHoleBuilder::FillHoles ( bool  globalUpdate)

Fills targeted holes.

Returns
updated input facet body
Created in NX6.0.0.

License requirements : None
Parameters
globalUpdateIf true, update the entire input facet body. If false, GetHoleFillsOnly() may be used to get a facet body that contains only the new facets of the filled holes.
void NXOpen::Facet::FillHoleBuilder::FindHoles ( )

Locates holes in the mesh and creates polylines around them.


Created in NX6.0.0.

License requirements : None

void NXOpen::Facet::FillHoleBuilder::GetAllHoles ( std::vector< NXOpen::DisplayableObject * > &  holeCurveTags)

Gets a list of all holes (represented by polylines).


Created in NX6.0.0.

License requirements : None

Parameters
holeCurveTagsHole polylines.
NXOpen::ICurve* NXOpen::Facet::FillHoleBuilder::GetHoleByIndex ( int  index)

Gets a hole given an index into the list of holes.

Returns
Equals NULL if not found
Created in NX6.0.0.

License requirements : None
Parameters
indexIndex into the list of all holes
NXOpen::DisplayableObject* NXOpen::Facet::FillHoleBuilder::GetHoleFillsOnly ( )

Builds a facet body that contains only the facets of the filled holes.

Returns
the fill facet body
Created in NX6.0.0.

License requirements : None
int NXOpen::Facet::FillHoleBuilder::GetNumberOfHoles ( )

Gets the number of holes in the target facet body.

Returns

Created in NX6.0.0.

License requirements : None
void NXOpen::Facet::FillHoleBuilder::GetTargetHolesByEdgeNumber ( int  numMaxEdges,
std::vector< NXOpen::DisplayableObject * > &  holeCurveTags 
)

Gets a list of targeted holes (represented by polylines) based on number of edges.


Created in NX6.0.0.

License requirements : None

Parameters
numMaxEdgesTargets polylines that have this many edges or less.
holeCurveTagsHole polylines.
NXOpen::SelectICurveList* NXOpen::Facet::FillHoleBuilder::InnerHole ( )

Returns the Inner Hole in island filling.


Created in NX6.0.0.

License requirements : None

bool NXOpen::Facet::FillHoleBuilder::IsEditCopy ( )

Returns the flag indicating if the hole filling is on the copy of the input facet body.


Created in NX12.0.0.

License requirements : None

int NXOpen::Facet::FillHoleBuilder::MaxEdges ( )

Returns the maximum number of edges that a targeted hole can have.


Created in NX6.0.0.

License requirements : None

NXOpen::SelectICurveList* NXOpen::Facet::FillHoleBuilder::OuterHole ( )

Returns the Outer Hole in island filling.


Created in NX6.0.0.

License requirements : None

void NXOpen::Facet::FillHoleBuilder::SetEditCopy ( bool  isEditCopy)

Sets the flag indicating if the hole filling is on the copy of the input facet body.


Created in NX12.0.0.

License requirements : studio_free_form ("STUDIO FREE FORM")

Parameters
isEditCopyiseditcopy
void NXOpen::Facet::FillHoleBuilder::SetMaxEdges ( int  maxEdges)

Sets the maximum number of edges that a targeted hole can have.


Created in NX6.0.0.

License requirements : studio_free_form ("STUDIO FREE FORM")

Parameters
maxEdgesmax edges
void NXOpen::Facet::FillHoleBuilder::SetSmoothType ( NXOpen::Facet::FillHoleBuilder::SmoothTypes  smoothType)

Sets the boundary smoothness.


Created in NX6.0.0.

License requirements : studio_free_form ("STUDIO FREE FORM")

Parameters
smoothTypesmooth type
void NXOpen::Facet::FillHoleBuilder::SetTargetType ( NXOpen::Facet::FillHoleBuilder::TargetTypes  targetType)

Sets the hole target type when filling holes.


Created in NX6.0.0.

License requirements : studio_free_form ("STUDIO FREE FORM")

Parameters
targetTypetarget type
void NXOpen::Facet::FillHoleBuilder::SetType ( NXOpen::Facet::FillHoleBuilder::Types  type)

Sets the hole filling type.


Created in NX6.0.0.

License requirements : studio_free_form ("STUDIO FREE FORM")

Parameters
typetype
NXOpen::Facet::FillHoleBuilder::SmoothTypes NXOpen::Facet::FillHoleBuilder::SmoothType ( )

Returns the boundary smoothness.


Created in NX6.0.0.

License requirements : None

void NXOpen::Facet::FillHoleBuilder::SwitchHoleFillType ( )

Switches boundary edge mapping based on the filling type (holes, island, bridge) When filling holes or islands, each hole is defined by a polyline.

When bridging holes, each individual open edge has its own polyline.


Created in NX6.0.0.

License requirements : None

NXOpen::SelectDisplayableObject* NXOpen::Facet::FillHoleBuilder::TargetBody ( )

Returns the facet body we will be filling.


Created in NX11.0.0.

License requirements : None

NXOpen::Facet::SelectFacetedBody* NXOpen::Facet::FillHoleBuilder::TargetFacetBody ( )

Returns the facet body we will be filling.


Deprecated:
Deprecated in NX11.0.0. Use NXOpen::Facet::FillHoleBuilder::TargetBody instead.


Created in NX6.0.0.

License requirements : None

NXOpen::SelectICurveList* NXOpen::Facet::FillHoleBuilder::TargetHole ( )

Returns the hole curves using Fill Hole, User Defined.


Created in NX6.0.0.

License requirements : None

NXOpen::Facet::FillHoleBuilder::TargetTypes NXOpen::Facet::FillHoleBuilder::TargetType ( )

Returns the hole target type when filling holes.


Created in NX6.0.0.

License requirements : None

NXOpen::Facet::FillHoleBuilder::Types NXOpen::Facet::FillHoleBuilder::Type ( )

Returns the hole filling type.


Created in NX6.0.0.

License requirements : None


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.